import skills

class LevelProgression(object):
    
    STATS = [ "hp", "base", "skill" ]
    
    def __init__(self):
        self.name="None"
    
    def getXpForLevel(self, level):
        if level == 1: return 0
        return self.getXpForLevel(level-1) + (level-1) * 1000
    
    def levelup(self, levelingTo):
        raise NotImplementedError
    
class WarriorLevelProgression(LevelProgression):
    def __init__(self):
        LevelProgression.__init__(self)
        self.name="Warrior"
        
    def levelup(self, levelingTo):
        skill = None
        if levelingTo % 2 == 1 and levelingTo < 10:
            skill = skills.PowerAttack(levelingTo/ 2 + 1)
        elif levelingTo == 2:
            skill = skills.Dodge()
        return dict(zip(self.STATS, (10, 1, skill)))

class WeenieLevelProgression(LevelProgression):
    def __init__(self):
        LevelProgression.__init__(self)
        self.name = "Weenie"
        
    def levelup(self, levelingTo):
        if levelingTo == 1:
            return dict(zip(self.STATS, (4, 0, None)))
        else:
            return dict(zip(self.STATS, (6, 0.5, None)))

class RogueLevelProgression(LevelProgression):
    def __init__(self):
        LevelProgression.__init__(self)
        self.name = 'Rogue'
        
    def levelup(self, levelingTo):
        if levelingTo == 1:
            return dict(zip(self.STATS, (6, 0, None)))
        else:
            return dict(zip(self.STATS, (6, 1, None)))