import random

import rpg
import classes

class RandomEnemyGenerator(object):
    def __init__(self):
        weenie = classes.WeenieLevelProgression()
        rogue = classes.RogueLevelProgression()
        warrior = classes.WarriorLevelProgression()
        self.enemies = [ ('Skull', 10, 'skull.png', weenie, 150), 
                         ('Eye Soldier', 8, 'greeneye.png', rogue, 200),
                         ('Lava Soul', 8, 'lava.png', warrior, 250),
                         ('Zombie', 8, 'zombie.png', weenie, 150),
                         ('Mutant', 8, 'mutant.png', rogue, 200),
                         ('Ghost', 8, 'ghost.png', weenie, 150)
                          ]
    
    def enemyForLevel(self, tiles, level):
        level = max(1, level / 2)
        name, frames, image, progression, modifier = random.choice(self.enemies)
        skull = rpg.Enemy(image, progression, tiles,frames,level)
        skull.world.center = tiles.tileToWorld(tiles.randomOpenTile())
        skull.name = name
        skull.xp = level * modifier
        #skull.xp = 1000
        
        return skull